<id>
Better Writelog for YaBB 2.1
</id>

<version>
1.1
</version>

<mod info>
Exist too many wiped and corrupted vars file. 
What fault is it? Server crash? May be.
Or many writing to a file at the same time. This is lock poblem.

Original writelog code to permit of .vars file update by anybody.

If user online but not active the last 15 (online logtime set) second, than active
users, guest, robots ..(anybody) updating one's .vars file.

After apply this mod:
- only owner can modify .vars file. This prevent (99% ?) vars file corruption. I think. I hope.. :D
- bit speedup: log file are locked awhile - not working on stream with other file 
- save server's memory: not loading users file, and not buildig mass memory arrays to every quest ip ;)


Installation:
1) Modify YaBB files using BoardMod or manually.
2) Load modified files to your server in ASCII mode.
Admin/ModList.pl (ASCII)
Sources/Subs.pl (ASCII)
Sources/Post.pl (ASCII)
Sources/InstantMessage.pl (ASCII)

Version History:
ver 1.0 - Initial release
ver 1.1	- 1 byte remove :D  ( replace $date2 with $date )

------
Gratis : 3 double write to same vars file improvement
</mod info>


<author>
Zoo
</author>

<homepage>

</homepage>

<edit file>
Admin/ModList.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
	$zoo_writelog = "Better Writelog|Zoltn Kovcs (Zoo)|Prevent user.vars update by anybody else.|1.1|17/01/07";
	push (@installed_mods, "$zoo_writelog");
</add before>

<edit file>
Sources/Subs.pl
</edit file>

<search for>
		# This check needs to be present to prevent thrashing of the user.vars file
		if ($result > ($OnlineLogTime * 60)) {
			if (!${$uid.$name}{'password'}) { &LoadUser($name); }
			&UserAccount($name, "update", "lastonline");
		}
	}
	fclose(LOG);
</search for>

<replace>
#		# This check needs to be present to prevent thrashing of the user.vars file
#		if ($result > ($OnlineLogTime * 60)) {
#			if (!${$uid.$name}{'password'}) { &LoadUser($name); }
#			&UserAccount($name, "update", "lastonline");
#		}
	}
	fclose(LOG);
	# rewrite own last online time - per minute
	if (!$iamguest && ${$uid.$username}{'lastonline'} < $date-60) { &UserAccount($username,"update","lastonline");}  
</replace>

<edit file>
Sources/Post.pl
</edit file>

<search for>
			${$uid.$username}{'postcount'}++;
			&UserAccount($username, "update", "lastpost");
			&UserAccount($username, "update", "lastonline");
</search for>

<replace>
			${$uid.$username}{'postcount'}++;
			&UserAccount($username, "update", "lastpost+lastonline"); 
</replace>

<search for>
		} else {
			&UserAccount($username, "update", "lastpost");
			&UserAccount($username, "update", "lastonline");
</search for>

<replace>
		} else {
			&UserAccount($username, "update", "lastpost+lastonline"); 
</replace>

<edit file>
Sources/InstantMessage.pl
</edit file>

<search for>
	&UserAccount($username, "update", "lastim");
	&UserAccount($username, "update", "lastonline");
</search for>

<replace>
	&UserAccount($username, "update", "lastim+lastonline");
</replace>


